diff -Naur newlib-1.20.0.orig/newlib/libc/sys/h8300hms/sys/file.h newlib-1.20.0/newlib/libc/sys/h8300hms/sys/file.h
--- newlib-1.20.0.orig/newlib/libc/sys/h8300hms/sys/file.h	2001-02-22 23:12:42.000000000 +0100
+++ newlib-1.20.0/newlib/libc/sys/h8300hms/sys/file.h	2012-03-28 10:11:12.301139339 +0200
@@ -3,7 +3,7 @@
  * Copyright (C) 1991 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/newlib/libc/sys/linux/machine/i386/setjmp.S newlib-1.20.0/newlib/libc/sys/linux/machine/i386/setjmp.S
--- newlib-1.20.0.orig/newlib/libc/sys/linux/machine/i386/setjmp.S	2002-05-18 01:39:38.000000000 +0200
+++ newlib-1.20.0/newlib/libc/sys/linux/machine/i386/setjmp.S	2012-03-28 10:11:12.301139339 +0200
@@ -8,7 +8,7 @@
  * Copyright (C) 1991 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/newlib/libc/sys/rtems/machine/_types.h newlib-1.20.0/newlib/libc/sys/rtems/machine/_types.h
--- newlib-1.20.0.orig/newlib/libc/sys/rtems/machine/_types.h	2010-11-16 18:29:39.000000000 +0100
+++ newlib-1.20.0/newlib/libc/sys/rtems/machine/_types.h	2012-03-28 10:11:12.301139339 +0200
@@ -13,7 +13,7 @@
  * could be applied here.
  */
 
-#if defined(__i386__) || defined(__m32r__) || defined(__h8300__) || defined(__arm__) || defined(__bfin__) || defined(__m68k__)
+#if defined(__i386__) || defined(__m32r__) || defined(__h8300__) || (defined(__arm__) && !defined(__ARM_EABI__)) || defined(__bfin__) || defined(__m68k__)
 #if defined(__H8300__)
 typedef signed int _ssize_t;
 #else
@@ -23,7 +23,7 @@
 #elif defined(__sparc__) && defined(__LP64__)
 typedef long signed int _ssize_t;
 #define __ssize_t_defined 1
-#elif defined(__AVR__) || defined(__lm32__) || defined(__m32c__) || defined(__mips__) || defined(__moxie__) || defined(__PPC__) || defined(__sparc__) || defined(__sh__)
+#elif defined(__AVR__) || defined(__lm32__) || defined(__m32c__) || defined(__mips__) || defined(__moxie__) || defined(__PPC__) || defined(__sparc__) || defined(__sh__) || defined(__ARM_EABI__)
 typedef signed int _ssize_t;
 #define __ssize_t_defined 1
 #else
diff -Naur newlib-1.20.0.orig/newlib/libc/sys/rtems/sys/utime.h newlib-1.20.0/newlib/libc/sys/rtems/sys/utime.h
--- newlib-1.20.0.orig/newlib/libc/sys/rtems/sys/utime.h	2002-11-07 20:27:36.000000000 +0100
+++ newlib-1.20.0/newlib/libc/sys/rtems/sys/utime.h	2012-03-28 10:11:12.302139355 +0200
@@ -1,10 +1,12 @@
 /*
- *  $Id: utime.h,v 1.1 2002/11/07 19:27:36 jjohnstn Exp $
+ *  $Id$
  */
 
 #ifndef __UTIME_h__
 #define __UTIME_h__
 
+#include <sys/types.h>
+
 #ifdef __cplusplus
 extern "C" {
 #endif
diff -Naur newlib-1.20.0.orig/newlib/libc/sys/sysmec/access.c newlib-1.20.0/newlib/libc/sys/sysmec/access.c
--- newlib-1.20.0.orig/newlib/libc/sys/sysmec/access.c	2001-02-22 23:12:43.000000000 +0100
+++ newlib-1.20.0/newlib/libc/sys/sysmec/access.c	2012-03-28 10:11:12.302139355 +0200
@@ -3,7 +3,7 @@
  * Copyright (C) 1993 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/newlib/libc/sys/sysnecv850/access.c newlib-1.20.0/newlib/libc/sys/sysnecv850/access.c
--- newlib-1.20.0.orig/newlib/libc/sys/sysnecv850/access.c	2001-02-22 23:12:43.000000000 +0100
+++ newlib-1.20.0/newlib/libc/sys/sysnecv850/access.c	2012-03-28 10:11:12.302139355 +0200
@@ -3,7 +3,7 @@
  * Copyright (C) 1993 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/newlib/libm/common/modfl.c newlib-1.20.0/newlib/libm/common/modfl.c
--- newlib-1.20.0.orig/newlib/libm/common/modfl.c	2009-04-18 00:15:43.000000000 +0200
+++ newlib-1.20.0/newlib/libm/common/modfl.c	2012-03-28 10:11:12.302139355 +0200
@@ -36,7 +36,7 @@
 long double
 modfl (long double x, long double *iptr)
 {
-  return modf(x, iptr);
+  return modf(x, (double*) iptr);
 }
 #endif
 
diff -Naur newlib-1.20.0.orig/newlib/libm/common/s_round.c newlib-1.20.0/newlib/libm/common/s_round.c
--- newlib-1.20.0.orig/newlib/libm/common/s_round.c	2009-03-25 20:13:01.000000000 +0100
+++ newlib-1.20.0/newlib/libm/common/s_round.c	2012-03-28 10:11:12.303139371 +0200
@@ -68,7 +68,7 @@
           msw &= 0x80000000;
           if (exponent_less_1023 == -1)
             /* Result is +1.0 or -1.0. */
-            msw |= (1023 << 20);
+            msw |= ((__int32_t)1023 << 20);
           lsw = 0;
         }
       else
diff -Naur newlib-1.20.0.orig/newlib/libm/math/e_scalb.c newlib-1.20.0/newlib/libm/math/e_scalb.c
--- newlib-1.20.0.orig/newlib/libm/math/e_scalb.c	2000-02-17 20:39:51.000000000 +0100
+++ newlib-1.20.0/newlib/libm/math/e_scalb.c	2012-03-28 10:11:12.303139371 +0200
@@ -17,6 +17,7 @@
  * should use scalbn() instead.
  */
 
+#include <limits.h>
 #include "fdlibm.h"
 
 #ifndef _DOUBLE_IS_32BITS
@@ -46,8 +47,17 @@
 	    else       return x/(-fn);
 	}
 	if (rint(fn)!=fn) return (fn-fn)/(fn-fn);
+#if (INT_MAX < 65000)
+	if ( fn > (double) INT_MAX) return scalbn(x, INT_MAX);
+#else
 	if ( fn > 65000.0) return scalbn(x, 65000);
-	if (-fn > 65000.0) return scalbn(x,-65000);
+#endif
+
+#if (INT_MIN > -65000)
+        if (fn < (double) INT_MIN) return scalbn(x,INT_MIN);
+#else
+	if (fn < -65000.0) return scalbn(x,-65000);
+#endif
 	return scalbn(x,(int)fn);
 #endif
 }
diff -Naur newlib-1.20.0.orig/newlib/Makefile.am newlib-1.20.0/newlib/Makefile.am
--- newlib-1.20.0.orig/newlib/Makefile.am	2011-05-19 08:04:59.000000000 +0200
+++ newlib-1.20.0/newlib/Makefile.am	2012-03-28 10:11:12.245138467 +0200
@@ -81,7 +81,7 @@
 	libc.a
 endif
 
-noinst_DATA = stmp-targ-include
+BUILT_SOURCES = stmp-targ-include
 
 toollib_DATA = $(CRT0) $(CRT1)
 
@@ -279,10 +279,6 @@
 	     $(INSTALL_DATA) $$i $(DESTDIR)$(tooldir)/include/machine/`basename $$i`; \
 	    else true; fi ; \
 	  done; \
-	  $(mkinstalldirs) $(DESTDIR)$(tooldir)/include/rpc; \
-	  for i in $(srcdir)/libc/include/rpc/*.h; do \
-	   $(INSTALL_DATA) $$i $(DESTDIR)$(tooldir)/include/rpc/`basename $$i`; \
-	  done; \
 	  $(mkinstalldirs) $(DESTDIR)$(tooldir)/include/sys; \
 	  for i in $(srcdir)/libc/include/sys/*.h; do \
 	   $(INSTALL_DATA) $$i $(DESTDIR)$(tooldir)/include/sys/`basename $$i`; \
@@ -330,11 +326,6 @@
 	     $(INSTALL_DATA) $$i $(DESTDIR)$(tooldir)/include/machine/`basename $$i`; \
 	    else true; fi ; \
 	  done ; \
-	  for i in $(NO_INCLUDE_LIST); do \
-	    if [ -f $(DESTDIR)$(tooldir)/include/$$i ]; then \
-		rm $(DESTDIR)$(tooldir)/include/$$i; \
-	    else true; fi ; \
-	  done ; \
 	else true; fi
 
 # Force makedoc to be built before building info files.
diff -Naur newlib-1.20.0.orig/newlib/testsuite/newlib.string/strcmp-1.c newlib-1.20.0/newlib/testsuite/newlib.string/strcmp-1.c
--- newlib-1.20.0.orig/newlib/testsuite/newlib.string/strcmp-1.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/newlib/testsuite/newlib.string/strcmp-1.c	2012-03-28 10:11:12.303139371 +0200
@@ -0,0 +1,222 @@
+/*
+ * Copyright (c) 2011 ARM Ltd
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. The name of the company may not be used to endorse or promote
+ *    products derived from this software without specific prior written
+ *    permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY ARM LTD ``AS IS'' AND ANY EXPRESS OR IMPLIED
+ * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL ARM LTD BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
+ * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+ * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
+ * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
+ * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <string.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <stdarg.h>
+
+#ifndef BUFF_SIZE
+#define BUFF_SIZE 1024
+#endif
+
+#ifndef MAX_BLOCK_SIZE
+#define MAX_BLOCK_SIZE 128
+#endif
+
+#ifndef MAX_OFFSET
+#define MAX_OFFSET 3
+#endif
+
+#ifndef MAX_DIFF
+#define MAX_DIFF 8
+#endif
+
+#ifndef MAX_LEN
+#define MAX_LEN 8
+#endif
+
+#ifndef MAX_ZEROS
+#define MAX_ZEROS 8
+#endif
+
+#if (MAX_OFFSET >= 26)
+#error "MAX_OFFSET >= 26"
+#endif
+
+#if (MAX_OFFSET + MAX_BLOCK_SIZE + MAX_DIFF + MAX_LEN + MAX_ZEROS >= BUFF_SIZE)
+#error "Buffer overrun: MAX_OFFSET + MAX_BLOCK_SIZE + MAX_DIFF + MAX_LEN + MAX_ZEROS >= BUFF_SIZE."
+#endif
+
+
+#define TOO_MANY_ERRORS 11
+int errors = 0;
+
+const char *testname = "strcmp";
+
+void
+print_error (char const* msg, ...)
+{
+  errors++;
+  if (errors == TOO_MANY_ERRORS)
+    {
+      fprintf (stderr, "Too many errors.\n");
+    }
+  else if (errors < TOO_MANY_ERRORS)
+    {
+      va_list ap;
+      va_start (ap, msg);
+      vfprintf (stderr, msg, ap);
+      va_end (ap);
+    }
+  else
+    {
+      /* Further errors omitted.  */
+    }
+}
+
+void
+printbuf (char *buf, char *name)
+{
+  int i;
+  printf ("\n %s=", name);
+  for (i = 0; i < BUFF_SIZE; i++)
+    if (buf[i] != 0)
+      printf ("(%d,%c)", i, buf[i]);
+    else
+      printf ("(%d,%s)", i, "\\0");
+  printf ("\n");
+}
+
+int
+main (void)
+{
+  /* Allocate buffers to read and write from.  */
+  char src[BUFF_SIZE], dest[BUFF_SIZE];
+
+  /* Fill the source buffer with non-null values, reproducable random data.  */
+  srand (1539);
+  int i, j, zeros;
+  unsigned sa;
+  unsigned da;
+  unsigned n, m, len;
+  char *p;
+  int ret;
+
+  /* Make calls to strcmp with block sizes ranging between 1 and
+     MAX_BLOCK_SIZE bytes, aligned and misaligned source and destination.  */
+  for (sa = 0; sa <= MAX_OFFSET; sa++)
+    for (da = 0; da <= MAX_OFFSET; da++)
+      for (n = 1; n <= MAX_BLOCK_SIZE; n++)
+	{
+	for (m = 1;  m < n + MAX_DIFF; m++)
+	  for (len = 0; len < MAX_LEN; len++)
+	    for  (zeros = 1; zeros < MAX_ZEROS; zeros++)
+	    {
+	      if (n - m > MAX_DIFF)
+		continue;
+	      /* Make a copy of the source.  */
+	      for (i = 0; i < BUFF_SIZE; i++)
+		{
+		  src[i] = 'A' + (i % 26);
+		  dest[i] = src[i];
+		}
+	      memcpy (dest + da, src + sa, n);
+
+	      /* Make src 0-terminated.  */
+	      p = src + sa + n - 1;
+	      for (i = 0; i < zeros; i++)
+		{
+		  *p++ = '\0';
+		}
+
+	      /* Modify dest.  */
+	      p = dest + da + m - 1;
+	      for (j = 0; j < len; j++)
+		*p++ = 'x';
+	      /* Make dest 0-terminated.  */
+	      *p = '\0';
+
+	      ret = strcmp (src + sa, dest + da);
+
+	      /* Check return value.  */
+	      if (n == m)
+		{
+		  if (len == 0)
+		    {
+		      if (ret != 0)
+			{
+			print_error ("\nFailed: after %s of %u bytes "
+				     "with src_align %u and dst_align %u, "
+				     "dest after %d bytes is modified for %d bytes, "
+				     "return value is %d, expected 0.\n",
+				     testname, n, sa, da, m, len, ret);
+			}
+		    }
+		  else
+		    {
+		      if (ret >= 0)
+			print_error ("\nFailed: after %s of %u bytes "
+				     "with src_align %u and dst_align %u, "
+				     "dest after %d bytes is modified for %d bytes, "
+				     "return value is %d, expected negative.\n",
+				     testname, n, sa, da, m, len, ret);
+		    }
+		}
+	      else if (m > n)
+		{
+		  if (ret >= 0)
+		    {
+		      print_error ("\nFailed: after %s of %u bytes "
+				   "with src_align %u and dst_align %u, "
+				   "dest after %d bytes is modified for %d bytes, "
+				   "return value is %d, expected negative.\n",
+				   testname, n, sa, da, m, len, ret);
+		    }
+		}
+	      else  /* m < n */
+		{
+		  if (len == 0)
+		    {
+		      if (ret <= 0)
+			print_error ("\nFailed: after %s of %u bytes "
+				     "with src_align %u and dst_align %u, "
+				     "dest after %d bytes is modified for %d bytes, "
+				     "return value is %d, expected positive.\n",
+				     testname, n, sa, da, m, len, ret);
+		    }
+		  else
+		    {
+		      if (ret >= 0)
+			print_error ("\nFailed: after %s of %u bytes "
+				     "with src_align %u and dst_align %u, "
+				     "dest after %d bytes is modified for %d bytes, "
+				     "return value is %d, expected negative.\n",
+				     testname, n, sa, da, m, len, ret);
+		    }
+		}
+	    }
+	}
+  printf ("\n");
+  if (errors != 0)
+    {
+      printf ("ERROR. FAILED.\n");
+      abort ();
+    }
+  exit (0);
+}
